#include "CRM32Pro.h"
#ifdef _WINDOWS
 #include <windows.h>
#endif

// ---Definiciones---
#define TUTORIAL_VERSION "Tutorial 1: Carga de superficies y blitting" //titulo de la ventana
#define IMG_RESOURCE "imagenes.dpf" //paquete de imagenes

// -------------FUNCION MAIN----------------
int main( int argc, char* args[] )
{
    // ---Variables---
    Uint8 done = 0;
    SDL_Rect dest;
    SDL_Event event;            //para recoger los eventos
    SDL_Surface *logo = NULL;   //Las superficies que utilizaremos
    SDL_Surface *background = NULL;

    //Iniciamos CRM32Pro
    if(CRM32Pro.Init(SDL_INIT_VIDEO) < 0)
    {
        printf("No se ha podido iniciar CRM32Pro: %s\n",SDL_GetError());
        return 1;
    }

    //Configuracion deseada
    CRM32Pro.Config.Title = TUTORIAL_VERSION; //titulo de la ventana
    CRM32Pro.Config.VideoWidth = 640;   //establecemos la resolucion: 640 de ancho
    CRM32Pro.Config.VideoHeight = 480;  //por 480 de alto
    CRM32Pro.Config.VideoBPP = 32;      //y una profunidad de bit de 32

    //Establecemos el modo de video
    if(!CRM32Pro.SetVideoMode())
    {
        CRM32Pro.Quit();
        return 1;
    }

    //Cargamos los graficos
    background = IImage->Load(IMG_RESOURCE,"background");
    logo = IImage->Load(IMG_RESOURCE,"logo");

    //Definimos donde dibujaremos el logo
    dest.x = 100;
    dest.y = 100;
    dest.w = logo->w;
    dest.h = logo->h;

    //copiamos las imagenes a la pantalla
    SDL_BlitSurface(background,NULL,CRM32Pro.screen,NULL);
    SDL_BlitSurface(logo,NULL,CRM32Pro.screen,&dest);

    // Mostramos la pantalla
    SDL_Flip(CRM32Pro.screen);

    // Esperamos la pulsacin de una tecla para salir
    while(done == 0) {
        while ( CRM32Pro.Update(&event) ) {
            if ( event.type == SDL_KEYDOWN )
                done = 1;
        }
    }

    //Liberamos las superficies
    CRM32Pro.FreeSurface(background);
    CRM32Pro.FreeSurface(logo);

    //Quit CRM32Pro
    CRM32Pro.Quit();

    return 0;
}

